package com.jojubanking.boot.module.system.service.wq;

import java.util.*;
import javax.validation.*;
import com.jojubanking.boot.module.system.controller.admin.wq.vo.*;
import com.jojubanking.boot.module.system.dal.dataobject.wq.WqDO;
import com.jojubanking.boot.framework.common.pojo.PageResult;

/**
 * 问卷调查 Service 接口
 *
 * @author admin
 */
public interface WqService {

    /**
     * 创建问卷调查
     *
     * @param createReqVO 创建信息
     * @return 编号
     */
    Integer createWq(@Valid WqCreateReqVO createReqVO);

    /**
     * 更新问卷调查
     *
     * @param updateReqVO 更新信息
     */
    void updateWq(@Valid WqUpdateReqVO updateReqVO);

    /**
     * 删除问卷调查
     *
     * @param id 编号
     */
    void deleteWq(Integer id);

    /**
     * 获得问卷调查
     *
     * @param id 编号
     * @return 问卷调查
     */
    WqDO getWq(Integer id);

    /**
     * 获得问卷调查列表
     *
     * @param ids 编号
     * @return 问卷调查列表
     */
    List<WqDO> getWqList(Collection<Integer> ids);

    /**
     * 获得问卷调查分页
     *
     * @param pageReqVO 分页查询
     * @return 问卷调查分页
     */
    PageResult<WqDO> getWqPage(WqPageReqVO pageReqVO);

    /**
     * 获得问卷调查列表, 用于 Excel 导出
     *
     * @param exportReqVO 查询条件
     * @return 问卷调查列表
     */
    List<WqDO> getWqList(WqExportReqVO exportReqVO);

}
